\name{viterbi}
\alias{viterbi}
\title{ find the most likely path }
\description{
}
\usage{
viterbi(x, p, a, du, pi, step, penalty = "BIC", b.limit = 0.001, cut)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{ a vector of observations }
  \item{p}{ a vector of the same length as x, indicating the positions(time) of observations x }
  \item{a}{ transition matrix }
  \item{du}{ duration probability matrix }
  \item{pi}{ initial probability }
  \item{step}{ length of one step }
  \item{penalty}{ penalty used while calculating likelihood }
  \item{b.limit}{ if the segmental model of one segment is linear model with a slope, b.limit is the minimum absolute value of the slope }
  \item{cut}{cutting point used in function logsumexp}
}
\details{
}
\value{
  A list of class "hmm.path": 
  \item{path }{a vector indicating the state at each step}
  \item{step }{the input parameter "step", length of each step}
  \item{x}{ the input parameter "x", the observations }
  \item{p}{ the input parameter "p", the positions/time }
  \item{segment}{ a matrix with two columns, each row describes one segemtn. The first column is the end step of each segment and the second column is the predicted "x" at the end of the segment. }
}
\references{ Rabiner L: A tutorial on hidden Markov models and selected applications in speech recognition. Proceedings of the IEEE 1989, 77(2):257-286.
}
\author{ Wei Sun sunwei@stat.ucla.edu }
\note{ }

\examples{

}
\keyword{ methods }
